/* PROLOG Java Version 0.1
Sergey Izwozchikow Copyright 1992, 1996 */

import java.lang.*;
import java.lang.String;
import java.util.*;
import java.io.IOException;

import Varname;
import Concret;
import Term;
import Sentence;

class Program extends Object {

//
  String Cut = "!";
  String False = "fail";
  String True = "true";

//
  long step;
  boolean trace;
  boolean searchall;
  boolean cut;
  Vector database;
  Vector questions;
  Vector concrets;

  Program()
  {
    long step = 1;
    boolean trace = false;
    boolean cut = false;
    Vector database = null;
    Vector questions = null;
    Vector concrets = null;
  }

  char analys(String s) {
    if( s.indexOf(":-") != -1) return 'r';
    if( s.indexOf("?-") != -1) return 'q';
    return 'f';
  }

// String sourceFile.
// p.read(sourceFile.toCharArray());
  void read(char[] file)
  {
    int ptr, st;
    String str, s;
    char chois;
    Sentence cur;

    ptr = 0;
    database = new Vector();
    questions = new Vector(1);
    while (ptr < file.length - 2)
    {
      st = Term.strchri(file,(char) '.', ptr);
      if (st != -1)
      {
        str = new String(file, ptr, st - ptr + 1);
        chois = analys(str);
        cur = new Sentence();
        cur.read(str.toCharArray(), chois);
        switch(chois)
        {
          case 'f':
          case 'r':
            database.addElement(cur);
            break;
          case 'q':
            questions.addElement(cur);
            break;
        }
      }
      else {
        String er = new String(file);
        throw new RuntimeException("Wrong term in string " + er);
      }
      ptr = st + 1;
   }
  }

  Vector cloneConcrets(Vector src)
  {
    Vector copy = new Vector(src.size());

    for (int i = 0; i < src.size(); i++)
      copy.addElement(new Concret((Concret) src.elementAt(i)));
    return copy;
  }

  void printSentences(Vector src)
  {
    for (int i = 0; i < src.size(); i++)
      ((Term) src.elementAt(i)).print();
  }

  boolean result(Vector concrets)
  {
    Concret c;
    char ch = ' ';

    System.out.print("\n");
    for (int i = 0; i < concrets.size(); i++)
    {
      c = (Concret) concrets.elementAt(i);
      if (c.name.indexOf("__") != 0)
      {
        System.out.print(c.name);
        System.out.print(" = ");
        printVariable(c.name, concrets);
        System.out.print("\n");
      }
    }
    if (trace == false)
    {
/*
      try {
        ch = (char) System.in.read();
      } catch (IOException eX2) {
        System.out.println("Run aborted!");
        return true;
      }
      if ( ch == ';')
*/
      if (searchall)
        return false;
      else
        return true;
    }
    else
      return false;
  }

  void printVariable(String name, Vector concrets)
  {
    Concret c;
    for (int i = 0; i < concrets.size(); i++)
    {
      c = (Concret) concrets.elementAt(i);
      if (c.name.equals(name))
      {
        if (c.object.type == Term.Variable)
          printVariable(c.object.name, concrets);
        else
        {
          Term o = place(c.object, concrets);
          o.print();
        }
        return;
      }
    }
    System.out.print(name);
  }

  void listSentences(Vector sentences)
  {
    if (sentences != null)
      for (int s = 0; s < sentences.size(); s++)
        ((Sentence) sentences.elementAt(s)).print();
  }

  Term place(Term purp, Vector concrets)
  {
    Concret c;
    Term ret = new Term(purp);

    if (purp == null) throw new NullPointerException();
    if (purp.type == Term.Functor) {
      ret = new Term();
      ret.name = new String(purp.name);
      ret.type = Term.Functor;
      ret.reps = purp.reps;
      ret.args = new Vector(purp.reps);
      for (int i = 0; i < purp.reps; i++)
        ret.args.addElement(place((Term) purp.args.elementAt(i), concrets));
    }
    else
      if (purp.type == Term.Variable)
        if (purp.name.equals("_") == false) /* visible variable */
          for (int i = 0; i < concrets.size(); i++)
          {
            c = (Concret) concrets.elementAt(i);
            if (c.name.equals(purp.name))
                /* && top -> numb_con == count_put) */
              purp = ret = place( c.object, concrets);
          }
    return ret;
  }

  boolean compute(Vector sentences, Vector target, Vector concrets)
  {
    boolean Succes = false, Cutlog = false, cuts = false;
    Sentence sentenceCopy;
    Term t = null;
    Vector newPurpose, curr;
    Vector concretsCopy;
    Vector varnames = new Vector();

    if (trace) System.out.println("COMPUTE");
    for (int i = 0; i < target.size(); i++) {
      t = (Term) target.elementAt(i);
      cuts = t.name.equals(Program.Cut);
      if (cuts) {
        cut = true;
        break;
      }
      if (t.name.equals(Program.True))
        break;
    }
    if (target.size() != 0 && ((Term) target.firstElement()).name.equals(Program.False))
      return false;
    if (target.size() == 0)
      Succes = result(concrets);
    else
    {
      if (trace)
      {
        System.out.print("\nTARGET : ");
        for (int j = 0; j < target.size(); j++)
        {
          ((Term) target.elementAt(j)).print();
          if (j < target.size())
            System.out.print(", ");
        }
        System.out.print("\n");
      }
      step += 1;
      for (int s = 0; s < sentences.size() && (Succes == false) &&
           (Cutlog == false); s++)
      {
        if (((Sentence) sentences.elementAt(s)).head.
            like((Term) target.firstElement()))
        {
          sentenceCopy = new Sentence((Sentence) sentences.elementAt(s));
          sentenceCopy.head.diffrent(varnames, step);
          if (sentenceCopy.body != null)
            for (int b = 0; b < sentenceCopy.body.size(); b++)
              ((Term) sentenceCopy.body.elementAt(b)).diffrent(varnames, step);
          if (trace)
          {
            System.out.print("\nDiffrent : ");
            sentenceCopy.print();
          }
          concretsCopy = cloneConcrets(concrets);
          if (((Term) target.firstElement()).
                            compare(sentenceCopy.head, concretsCopy, step))
          {
            String st = Long.toString(step, 10);
            if (trace) System.out.print("\nStep number " + st);
            if (sentenceCopy.body == null)
              sentenceCopy.body = new Vector(target.size());
            for (int n = 1; n < target.size(); n++)
              sentenceCopy.body.
                          addElement(new Term((Term) target.elementAt(n)));
            curr = sentenceCopy.body;
            int bsize = sentenceCopy.body.size();
            sentenceCopy.body = null;
            newPurpose = new Vector(bsize);
            for (int m = 0; m < bsize; m++)
              newPurpose.addElement(place((Term) curr.elementAt(m), concretsCopy));
            Succes = compute( sentences, newPurpose, concretsCopy);
            if (((Sentence) sentences.elementAt(s)).cuts) Cutlog = false;
          }
          else
            if (trace) System.out.print("\nComparision is not successfull\n");
        }
      }
      step -= 1;
      if (Cutlog) cut = true;
    }
    return Succes;
  }

  void run()
  {
    System.out.println("\nPROLOG Java Version 0.1");
    System.out.println("\nSergey Izwozchikow Copyright(C) 1992, 1996");
    System.out.print("\nDatabase : \n");
    listSentences(database);
    System.out.print("\nQuestions : \n");
    listSentences(questions);
    for (int i = 0; i < questions.size(); i++)
    {
      concrets = new Vector();
      if (compute(database, ((Sentence) questions.elementAt(i)).body, concrets))
        System.out.println("Yes!");
      else
        System.out.println("No!");
    }
  }
}
