import java.applet.Applet;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.StringTokenizer;
import Program;

public class Prolog extends Applet {
    public static void main(String args[]) {
	  if (args.length < 1) {
        System.out.println("Use: Prolog [-t] [-r] filename.pro");
        System.out.println("-t Trace execution");
        System.out.println("-r Do automatic returns");
		return;
	  }
      Prolog p = new Prolog();
      p.init();
      p.start();
      Program prg = new Program();
      prg.trace = false;
      prg.searchall = false;
      for (int j = 0; j < args.length; j++) {
        if (args[j].equals("-t")) 
          prg.trace = true;
        else if (args[j].equals("-r")) 
          prg.searchall = true;
		else { args[0] = args[j]; break; }
      }
      File fileName = new File(args[0]);
      FileInputStream fIn = null;
      try {
        fIn = new FileInputStream(fileName);
      } catch (FileNotFoundException eX1) {
        System.out.println("File not found!");
        return;
      };         
      int l = (int)fileName.length();
      byte buffer[] = new byte[l + 1];
      try {
        fIn.read(buffer, 0, l + 1);
      } catch (IOException eX2) {
        System.out.println("Error reading file!");
        return;
      }
      String text = new String(buffer, 0x0);
      StringBuffer stext = new StringBuffer();
      for (StringTokenizer t = new StringTokenizer(text) ; t.hasMoreTokens() ; )
        stext.append(t.nextToken());
      String prog = stext.toString();
      prg.read(prog.toCharArray());
      prg.run();
    }
}
