/* PROLOG Java Version 0.1
Sergey Izwozchikow Copyright 1992, 1996 */

import java.lang.*;
import java.util.*;

import Term;
import Concret;
import Varname;

class Sentence extends Object {
  String Cut = "!";

  boolean cuts;
  Term head;
  Vector body;

  Sentence()
  {
    cuts = false;
    head = null;
    body = null;
  }

  Sentence(Sentence src)
  {
    this();
    if( src == null) throw new NullPointerException();
    cuts = src.cuts;
    if (src.head != null) head = new Term(src.head);
    if (src.body != null) {
      body = new Vector(src.body.size());
      for (int i = 0; i < src.body.size(); i++)
        body.addElement(new Term((Term) src.body.elementAt(i)));
    }
  }

  void read(char[] src, char u)
  {
    int s = 0, nxt;
    String str, trm;
    Term t;

    cuts = false;
    if (u == 'q') head = null;
    if (u == 'f' || u == 'r')
    {
      while ((s < src.length) && (src[s] != ((char) ':')) && (src[s] != ((char) '.'))) s++;
      str = new String(src, 0, s);
      head = new Term();
      head.read(str.toCharArray());
    }
    if (u == 'f') body = null;
    if (u == 'r' || u == 'q')
    {
      s += 2;       /* :- or ?- */
      body = new Vector(1, 1);
      str = new String(src, s, src.length - s);
      nxt = Term.get(str.toCharArray());
      while ( nxt != -1)
      {
        nxt += s;
        t = new Term();
        trm = new String(src, s, nxt - s);
        t.read(trm.toCharArray());
        body.addElement(t);
        if (t.name.equals(Sentence.Cut))
          cuts = true;
        if (src[nxt] == ((char) '.'))
          break;
        s = nxt + 1;
        str = new String(src, s, src.length - s);
        nxt = Term.get(str.toCharArray());
      }
    }
 }

  void print()
  {
    if (head != null)
      head.print();
    if (body != null)
    {
      int r = body.size();
      if (head != null)
        System.out.print(":-");
      else
        System.out.print("?-");
      for (int i = 0; i < body.size(); i++)
      {
        ((Term) body.elementAt(i)).print();
        if (i < r - 1)
          System.out.print(", ");
      }
    }
    System.out.print(".\n");
  }
}
